#include <algorithm>
#include <cctype>
#include <cmath>
#include <complex>
#include <cstdio>
#include <cstring>
#include <iomanip>
#include <iostream>
#include <list>
#include <map>
#include <queue>
#include <set>
#include <sstream>
#include <stack>
#include <string>
#include <utility>
#include <vector>
using namespace std;

#define DEBUG(x) cout << ">>> " << #x << " : " << x << endl;
#define REP(i,a) for (int i = 0; i < (a); ++i)
#define FOR(i,a,b) for (int i = (a); i <= (b); ++i)
#define FORD(i,a,b) for (int i = (a); i >= (b); --i)
inline bool EQ(double a, double b) { return fabs(a-b) < 1e-9; }

const int INF = 1<<29;
typedef long long ll;
///////////////////////////////////////////////////////////////////////////

const int MAX = 1007, MAX2 = 2000007;
int T, shift[MAX], state[MAX2];
char bug[MAX], input[MAX2];

int main()
{
  while (scanf("%d %s\n", &T, bug) == 2)
  {
    int len = strlen(bug);
    shift[0] = -1;
    for (int i = 0, j = -1; i < len; shift[++i] = ++j)
      while (j >= 0 && bug[i] != bug[j])
	j = shift[j];
      
    while (T--)
    {
      gets(input);
      int len2 = 0, j = 0;
      for (int i = 0; input[i]; ++i)
      {
	input[len2] = input[i];
	while (j >= 0 && bug[j] != input[i])
	  j = shift[j];
	++j;
	state[len2] = j;
	++len2;
	if (j == len)
	{
	  len2 -= len;
	  j = (len2?state[len2-1]:0);
	}
      }
      input[len2] = 0;
      printf("%s\n", input);
    }
  }
  
  return 0;
}
